/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const q=require("react"),u=require("prop-types"),B=require("../common/SearchBar.js"),V=require("../common/ListContainer.js"),T=require("../common/List.js"),w=require("../common/DropDownBase.js"),N=require("../common/GroupStickyHeader.js"),c=require("../common/utils.js"),l=require("@progress/kendo-react-common"),R=require("@progress/kendo-react-labels"),L=require("../package-metadata.js"),A=require("../common/ClearButton.js"),z=require("../common/AdaptiveMode.js"),D=require("../common/withCustomComponent.js"),H=require("@progress/kendo-react-layout"),W=require("../common/ListFilter.js");function j(C){const a=Object.create(null,{[Symbol.toStringTag]:{value:"Module"}});if(C){for(const e in C)if(e!=="default"){const t=Object.getOwnPropertyDescriptor(C,e);Object.defineProperty(a,e,t.get?t:{enumerable:!0,get:()=>C[e]})}}return a.default=C,Object.freeze(a)}const g=j(q),G="Please enter a valid value!",{sizeMap:_,roundedMap:U}=l.kendoThemeMaps,I=class I extends g.Component{constructor(a){super(a),this.state={},this.base=new w(this),this._element=null,this._suggested="",this._input=null,this._adaptiveInput=null,this._skipFocusEvent=!1,this._isScrolling=!1,this.itemHeight=0,this.focus=()=>{this._input&&this._input.focus()},this.handleItemSelect=(e,t)=>{const s=c.getFilteredData(this.props),i=c.getItemValue(s[e],this.props.textField);this.state.text&&!this.mobileMode&&(this.state.text&&(t.data.text=""),this.base.filterChanged("",t)),this._adaptiveInput&&this._adaptiveInput.blur(),this.triggerOnChange(i,t)},this.itemFocus=(e,t)=>{const{textField:s}=this.props,o=c.getFilteredData(this.props)[e];c.areSame(this.state.focusedItem,o,s)||(t.data.focusedItem=o)},this.togglePopup=e=>{this.base.togglePopup(e)},this.setValidity=()=>{this._input&&this._input.setCustomValidity&&this._input.setCustomValidity(this.validity.valid?"":this.props.validationMessage||G)},this.renderAdaptiveListContainer=()=>{const{adaptiveTitle:e}=this.props,{windowWidth:t=0}=this.state,s=g.createElement(W,{value:this.value,ref:o=>this._adaptiveInput=o&&o.element,onChange:this.onChangeHandler,onKeyDown:this.onInputKeyDown,size:this.props.size,rounded:this.props.rounded,fillMode:this.props.fillMode}),i={title:e,expand:this.opened,onClose:o=>this.onCancel(o),windowWidth:t,mobileFilter:s};return g.createElement(z.AdaptiveMode,{...i},g.createElement(H.ActionSheetContent,{overflowHidden:!0},g.createElement("div",{className:"k-list-container"},this.listContainerContent())))},this.onCancel=e=>{const t=this.base.initState();t.syntheticEvent=e,e.stopPropagation(),this.opened&&this.base.togglePopup(t),t.events.push({type:"onCancel"});const s=this.state.text;c.isPresent(s)&&s!==""&&this.base.filterChanged("",t),this.state.text&&(t.data.text=""),this.applyState(t)},this.listContainerContent=()=>{const{header:e,footer:t,size:s,groupStickyHeaderItemRender:i,groupField:o,list:d}=this.props,r=c.getFilteredData(this.props);let{group:n}=this.state;return n===void 0&&o!==void 0&&(n=c.getItemValue(r[0],o)),g.createElement(g.Fragment,null,e&&g.createElement("div",{className:"k-list-header"},e),g.createElement("div",{className:l.classNames("k-list",{[`k-list-${this.mobileMode?"lg":_[s]||s}`]:s})},!d&&n&&r.length!==0&&g.createElement(N,{group:n,groupMode:"modern",render:i}),this.renderList()),t&&g.createElement("div",{className:"k-list-footer"},t))},this.onScroll=e=>{this._isScrolling=!0;const{list:t}=this.base,{groupField:s}=this.props;let i=c.getFilteredData(this.props);if(!s||!i.length)return;const o=this.itemHeight||(t?t.children[0].offsetHeight:0),r=e.target.scrollTop;s&&(i=this.base.getGroupedDataModernMode(i,s));let n=i[0][s];for(let p=1;p<i.length&&!(o*p>r);p++)i[p]&&i[p][s]&&(n=i[p][s]);n!==this.state.group&&this.setState({group:n})},this.handleItemClick=(e,t)=>{this.base.handleItemClick(e,t),this._valueDuringOnChange=void 0},this.onChangeHandler=e=>{const s=this.base.initState(),i=this.mobileMode?e.target.element:e.currentTarget,o=i.value,d=i.selectionEnd===o.length;s.syntheticEvent=e;const r=this._suggested,n=this.value,p=n&&n.substring(0,n.length-r.length),v=p&&p===o,m=p&&p.length>o.length,{suggest:y}=this.props,h=this.props.opened!==void 0?this.props.opened:this.state.opened;if(y!==void 0&&y!==!1){v||m||!d?this._suggested="":this.suggestValue(o);const f=o+this._suggested,b={userInput:o,value:this._suggested};this.triggerOnChange(f,s,{suggestion:b})}else this._suggested="",this.triggerOnChange(o,s);(!h&&o||h&&!o)&&this.togglePopup(s),s.data.focusedItem=void 0,this.applyState(s),this.setState({group:void 0})},this.clearButtonClick=e=>{const s=this.base.initState(),i=this.props.opened!==void 0?this.props.opened:this.state.opened;s.syntheticEvent=e;const o="";this._suggested="",this.triggerOnChange(o,s),this.state.focusedItem!==void 0&&(s.data.focusedItem=void 0),i&&this.togglePopup(s),this.applyState(s)},this.onInputKeyDown=e=>{const{skipDisabledItems:t,groupField:s,textField:i}=this.props,o=c.getFilteredData(this.props);this._isScrolling&&(this._isScrolling=!1);const d=this.focusedIndex(),r=o[d],n=e.keyCode,p=e.altKey,v=this.props.opened!==void 0?this.props.opened:this.state.opened,m=this.base.initState();m.syntheticEvent=e;const y=()=>{v&&e.preventDefault()};if(p&&n===l.Keys.down)this.setState({opened:!0});else if(p&&n===l.Keys.up)this.setState({opened:!1});else if(v&&n===l.Keys.pageUp)y(),this.base.scrollPopupByPageSize(-1);else if(v&&n===l.Keys.pageDown)y(),this.base.scrollPopupByPageSize(1);else if(v&&(n===l.Keys.enter||n===l.Keys.esc))y(),t===!1&&r&&r.disabled?(v&&this.togglePopup(m),this.applyState(m)):this.applyInputValue(e.currentTarget.value,m,e.keyCode);else if(!v&&n===l.Keys.esc){const h="";this._suggested="",this.triggerOnChange(h,m),this.state.focusedItem!==void 0&&(m.data.focusedItem=void 0),this.applyState(m)}else if(n===l.Keys.up||n===l.Keys.down){if(s!==""&&i)if(!this.props.skipDisabledItems&&v)this.onNavigate(m,n);else{let h=0;if(n===l.Keys.down||n===l.Keys.right){const f=o.slice(d+1).find(b=>!b.disabled&&b[i]);h=f&&o.findIndex(b=>b[i]===f[i])}else if(n===l.Keys.up||n===l.Keys.left){let f;if(d===-1)f=o,h=o.findIndex(b=>!b.disabled&&b[i]);else{f=o.slice(0,d);let b=f.pop();for(;b&&b.disabled;)b=f.pop();h=b&&o.findIndex(S=>S[i]===b[i])}}if(h!==void 0){const f=h-d;this.onNavigate(m,n,f)}else h===void 0&&o.findIndex(f=>f[i])===o.length-1&&this.onNavigate(m,n)}else if(!this.props.skipDisabledItems&&v)this.onNavigate(m,n);else{let h=null;if(n===l.Keys.down||n===l.Keys.right)h=o.slice(d+1).find(f=>!f.disabled);else if(n===l.Keys.up||n===l.Keys.left){const f=o.slice(0,d);for(h=f.pop();h&&h.disabled;)h=f.pop()}if(h){const f=h.id-d-1;this.onNavigate(m,n,f)}else this.onNavigate(m,n)}this.applyState(m),y()}},this.handleFocus=e=>{this._skipFocusEvent||this.base.handleFocus(e)},this.handleBlur=e=>{const t=this.base.initState();!this.state.focused||this._skipFocusEvent||(t.syntheticEvent=e,t.data.focused=!1,t.events.push({type:"onBlur"}),this.opened&&!this.mobileMode&&(this.state.opened&&(t.data.opened=!1),t.events.push({type:"onClose"})),this.applyState(t))},this.handleWrapperClick=e=>{const t=this._input;!this.opened&&t&&this.focusElement(t);const s=this.base.initState();s.syntheticEvent=e,!this.state.focused&&!this.mobileMode&&(s.events.push({type:"onFocus"}),s.data.focused=!0),this.mobileMode&&window.setTimeout(()=>this._adaptiveInput&&this._adaptiveInput.focus(),300),this.base.togglePopup(s),this.applyState(s)},l.validatePackage(L.packageMetadata)}get _inputId(){return this.props.id+"-accessibility-id"}get document(){if(l.canUseDOM)return this.element&&this.element.ownerDocument||document}get element(){return this._element}get value(){return this._valueDuringOnChange!==void 0?this._valueDuringOnChange:this.props.value!==void 0?this.props.value:this.state.value!==void 0?this.state.value:this.props.defaultValue!==void 0?this.props.defaultValue:""}get name(){return this.props.name}get validity(){const a=this.props.validationMessage!==void 0,e=!this.required||this.value!=="",t=this.props.valid!==void 0?this.props.valid:e;return{customError:a,valid:t,valueMissing:this.value===null}}get opened(){return!!(this.props.opened!==void 0?this.props.opened:this.state.opened)}get mobileMode(){var e;return!!(this.state.windowWidth&&this.props._adaptiveMode&&this.state.windowWidth<=((e=this.props._adaptiveMode)==null?void 0:e.medium)&&this.props.adaptive)}get validityStyles(){return this.props.validityStyles!==void 0?this.props.validityStyles:I.defaultProps.validityStyles}get required(){return this.props.required!==void 0?this.props.required:I.defaultProps.required}componentDidUpdate(a,e){var y;const{groupField:t=""}=this.props,s=c.getFilteredData(this.props),{data:i=[]}=a,o=this.focusedIndex(),d=s[o],r=i!==s,n=d!==void 0&&e.focusedItem!==d,p=this.props.opened!==void 0?this.props.opened:this.state.opened,v=a.opened!==void 0?a.opened:e.opened,m=!v&&p;if(t==="")(p&&(n||r)||m)&&this.base.scrollToItem(o);else if(!this._isScrolling){const h=(y=this.base.getGroupedDataModernMode(s,t))==null?void 0:y.indexOf(d);m&&(s&&s.length!==0&&this.base.resetGroupStickyHeader(s[0][t],this),this.base.scrollToItem(h)),p&&v&&n&&this.base.scrollToItem(h)}this.setValidity()}componentDidMount(){var a;this.observerResize=l.canUseDOM&&window.ResizeObserver&&new window.ResizeObserver(this.calculateMedia.bind(this)),this.base.didMount(),this.setValidity(),(a=this.document)!=null&&a.body&&this.observerResize&&this.observerResize.observe(this.document.body)}render(){const{dir:a,disabled:e,label:t,className:s,style:i,loading:o,suggest:d,size:r,rounded:n,fillMode:p}=this.props,v=!this.validityStyles||this.validity.valid,m=this.base,y=this.value,h=this.props.clearButton!==!1&&!o&&!!y,f=this.props.id||this._inputId,b=this.state.focused;typeof d=="string"&&(this._suggested=d);const[S,O]=D(this.props.prefix||g.Fragment),[P,K]=D(this.props.suffix||g.Fragment),k=g.createElement(g.Fragment,null,g.createElement("span",{className:l.classNames("k-autocomplete k-input",s,{[`k-input-${_[r]||r}`]:r,[`k-rounded-${U[n]||n}`]:n,[`k-input-${p}`]:p,"k-invalid":!v,"k-focus":b&&!e,"k-loading":o,"k-required":this.required,"k-disabled":e}),ref:F=>{this._element=F,m.wrapper=F},style:t?{...i,width:void 0}:i,dir:a,onFocus:this.handleFocus,onBlur:this.handleBlur,onClick:this.handleWrapperClick},this.props.prefix&&g.createElement(S,{...O}),this.renderSearchBar(y||"",f),o&&g.createElement(l.IconWrap,{className:"k-input-loading-icon",name:"loading"}),h&&!o&&g.createElement(A,{onClick:this.clearButtonClick,key:"clearbutton"}),this.props.suffix&&g.createElement(P,{...K}),!this.mobileMode&&this.renderListContainer()),this.mobileMode&&this.renderAdaptiveListContainer());return t?g.createElement(R.FloatingLabel,{label:t,editorId:f,editorValue:y,editorValid:v,editorDisabled:e,style:{width:i?i.width:void 0},children:k}):k}onNavigate(a,e,t){const s=this.value,{textField:i,focusedItemIndex:o}=this.props,d=c.getFilteredData(this.props),r=this.state.focusedItem!==void 0?d.findIndex(p=>c.areSame(p,this.state.focusedItem,i)):o?o(d,s,i):d.indexOf(c.getFocusedItem(d,s,i)),n=this.base.navigation.navigate({keyCode:e,current:r,max:d.length-1,min:0,skipItems:t||void 0});n!==void 0&&this.itemFocus(n,a),this.applyState(a)}applyInputValue(a,e,t){const s=this.props.opened!==void 0?this.props.opened:this.state.opened,{textField:i}=this.props,o=c.getFilteredData(this.props),d=this.focusedIndex(),r=o[d];if(this._suggested="",s&&t===l.Keys.enter&&r&&!r.disabled){const n=c.getItemValue(o[this.focusedIndex(a)],i);this.triggerOnChange(n,e)}s&&this.togglePopup(e),this.applyState(e)}renderSearchBar(a,e){const t=this.base,{placeholder:s,tabIndex:i,disabled:o,readonly:d,inputAttributes:r}=this.props,{focused:n}=this.state,p=this.props.opened!==void 0?this.props.opened:this.state.opened;return g.createElement(B,{id:e,placeholder:s,tabIndex:i,accessKey:this.props.accessKey,value:a,suggestedText:this._suggested,focused:n,name:this.props.name,ref:v=>this._input=v&&v.input,onKeyDown:this.onInputKeyDown,onChange:this.onChangeHandler,onFocus:t.handleFocus,onBlur:this.handleBlur,disabled:o,readOnly:d,expanded:p,owns:t.listBoxId,activedescendant:"option-"+t.guid+"-"+this.focusedIndex(),role:"combobox",ariaLabelledBy:this.props.ariaLabelledBy,ariaDescribedBy:this.props.ariaDescribedBy,ariaRequired:this.required,render:this.props.valueRender,inputAttributes:r})}renderListContainer(){const a=this.base,{dir:e,groupField:t}=this.props,s=c.getFilteredData(this.props),i=a.getPopupSettings(),o=this.props.opened!==void 0?this.props.opened:this.state.opened,d=i.width!==void 0?i.width:a.popupWidth;let{group:r}=this.state;return r===void 0&&t!==void 0&&(r=c.getItemValue(s[0],t)),g.createElement(V,{width:d,popupSettings:{...i,anchor:i.anchor||this.element,show:o,popupClass:l.classNames(i.popupClass,"k-list-container","k-autocomplete-popup")},dir:e!==void 0?e:this.base.dirCalculated,itemsCount:[s.length]},this.listContainerContent())}renderList(){const a=this.base,e=a.getPopupSettings(),{textField:t,listNoDataRender:s,itemRender:i,groupHeaderItemRender:o}=this.props,d=c.getFilteredData(this.props),r=this.value,n=this.props.opened!==void 0?this.props.opened:this.state.opened;return g.createElement(T,{id:a.listBoxId,show:n,data:d.slice(),focusedIndex:this.focusedIndex(),value:r,textField:t,valueField:t,highlightSelected:!1,optionsGuid:a.guid,groupField:this.props.groupField,groupMode:"modern",listRef:p=>a.list=p,wrapperStyle:this.mobileMode?{}:{maxHeight:e.height},wrapperCssClass:"k-list-content",onClick:this.handleItemClick,itemRender:i,groupHeaderItemRender:o,noDataRender:s,onMouseDown:p=>p.preventDefault(),onScroll:this.onScroll})}triggerOnChange(a,e,t){this.value===a&&!t||(e.data.value=a,this._valueDuringOnChange=a,e.events.push({type:"onChange",...t||{}}))}focusElement(a){this._skipFocusEvent=!0,a.focus(),window.setTimeout(()=>this._skipFocusEvent=!1,0)}applyState(a){this.base.applyState(a),this._valueDuringOnChange=void 0}suggestValue(a){if(this._suggested="",a){const{textField:e}=this.props,t=c.getFilteredData(this.props),s=t[c.itemIndexStartsWith(t,a,e)];if(s){const i=c.getItemValue(s,e);a.toLowerCase()!==i.toLowerCase()&&(this._suggested=i.substring(a.length))}}}focusedIndex(a){const{textField:e,focusedItemIndex:t,skipDisabledItems:s}=this.props,i=c.getFilteredData(this.props),o=a!==void 0?a:this.value;if(this.state.focusedItem!==void 0)return i.findIndex(r=>c.areSame(r,this.state.focusedItem,e));if(t)return t(i,o,e);const d=i.indexOf(c.getFocusedItem(i,o,e));return s&&e&&d===-1?i.findIndex(r=>!r.disabled&&r[e]):Math.max(0,d)}calculateMedia(a){for(const e of a)this.setState({windowWidth:e.target.clientWidth})}};I.displayName="AutoComplete",I.propTypes={...w.basicPropTypes,size:u.oneOf([null,"small","medium","large"]),rounded:u.oneOf([null,"small","medium","large","full"]),fillMode:u.oneOf([null,"solid","flat","outline"]),groupField:u.string,suggest:u.oneOfType([u.bool,u.string]),placeholder:u.string,value:u.string,defaultValue:u.string,validationMessage:u.string,required:u.bool,readonly:u.bool,clearButton:u.bool,valueRender:u.func,id:u.string,ariaLabelledBy:u.string,ariaDescribedBy:u.string,list:u.any,adaptive:u.bool,adaptiveTitle:u.string,onCancel:u.func,skipDisabledItems:u.bool,inputAttributes:u.object},I.defaultProps={...w.defaultProps,size:"medium",rounded:"medium",fillMode:"solid",skipDisabledItems:!0,prefix:void 0,suffix:void 0};let x=I;const M=l.createPropsContext(),E=l.withIdHOC(l.withPropsContext(M,l.withAdaptiveModeContext(x)));E.displayName="KendoReactAutoComplete";exports.AutoComplete=E;exports.AutoCompletePropsContext=M;exports.AutoCompleteWithoutContext=x;
